Imports System.Data.Common
Imports System.Data
Imports System.Data.SQLite
Public Class Seleccion
    Dim ruta As String = ""
    Dim baseDeDatos As String = ""
    Dim tablaPrimaria As String = ""
    Dim condicionSelect = ""
    Dim stringOrder = ""
    Dim Llaves(20) As String
    Dim nCampos, nKeys, colBusqueda As Integer
    Dim cnn As SQLiteConnection

    Private Sub Seleccion_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ruta = Application.StartupPath() + "\"
        'Generar el orden
        Dim nombres(nCampos), valores(nCampos) As String
        Dim Keys(nKeys) As Integer
        cargarNombresYNumsLlave(tablaPrimaria, nombres, Keys)
        stringOrder = " ORDER BY"
        If nKeys = 1 Then
            stringOrder = stringOrder + " " + nombres(Keys(1))
        Else
            stringOrder = stringOrder + " " + nombres(Keys(1))
            Dim i As Integer
            For i = 2 To nKeys
                stringOrder = stringOrder + " , " + nombres(Keys(i))
            Next i
        End If
        'MsgBox(stringOrder)
        '1.-Definir el Comando Select del Data Adapter
        Dim selectSQL As String
        If condicionSelect.Equals("") Then
            selectSQL = "SELECT * " + " FROM " + tablaPrimaria + stringOrder
        Else
            selectSQL = "SELECT * " + " FROM " + tablaPrimaria + " " + condicionSelect + stringOrder
        End If
        '2.-Definir Conexion con la BD
        cnn = ConectarBD()
        '3.-Definir el Data Adapter
        Dim tablaDA As SQLiteDataAdapter = New SQLiteDataAdapter()
        Dim ObjComando As DbCommand = cnn.CreateCommand()
        ObjComando.CommandText = selectSQL
        tablaDA.SelectCommand = ObjComando
        '5.-Definir el Dataset
        Dim tablaDS As DataSet = New DataSet("Tabla")
        '6.-Llenar el Data Set
        Try
            tablaDA.Fill(tablaDS, "Registros Disponibles")
        Catch ex As Exception
            MsgBox("Seleccion: Error con mensaje (" & ex.Message & ")" & vbCrLf & "comando utilizado (" & selectSQL & ")")
        End Try
        '7-Ligar el Data Set con el GridView
        DataGridView1.DataSource = tablaDS.Tables(0)
        Me.Text = "Seleccion De Registros de la Tabla de " & tablaPrimaria
        cargaCombo()
    End Sub

    Private Sub DataGridView1_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridView1.MouseClick
        Dim i As Integer
        For i = 1 To nKeys
            Llaves(i) = DataGridView1.CurrentRow.Cells(i - 1).Value.ToString()
        Next i
        cnn.Close()
        cnn.Dispose()
        Me.Close()
        Me.Dispose()
    End Sub
    Public Sub Inicia(ByVal tablaEnviada As String, _
                           ByRef valorLlaves() As String)
        'Inicia desde el programa que lo requiere
        tablaPrimaria = tablaEnviada
        nCampos = Util.numeroCampos(tablaPrimaria, nCampos, nKeys)
        Me.ShowDialog()
        Dim i As Integer
        For i = 1 To nKeys
            valorLlaves(i) = Llaves(i)
        Next i
        Return
    End Sub
    Public Sub Inicia(ByVal tablaEnviada As String, _
                      ByRef valorLlaves() As String, _
                      ByVal condicionEnviada As String)
        'Inicia desde el programa que lo requiere
        tablaPrimaria = tablaEnviada
        condicionSelect = condicionEnviada
        nCampos = Util.numeroCampos(tablaPrimaria, nCampos, nKeys)
        Me.ShowDialog()
        Dim i As Integer
        For i = 1 To nKeys
            valorLlaves(i) = Llaves(i)
        Next i
        Return
    End Sub
    Public Sub CargaCombo()
        Dim nombreCol As String
        Dim i As Integer
        ComboBox1.Items.Add("")
        For i = 0 To DataGridView1.ColumnCount - 1
            nombreCol = DataGridView1.Columns(i).Name
            ComboBox1.Items.Add(nombreCol)
        Next i
        ComboBox1.SelectedIndex = 0
        colBusqueda = 0
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim argBusqueda, valorCelda As String
        Dim i As Integer
        argBusqueda = InputBox("Teclee el argumento de busqueda")
        argBusqueda = argBusqueda.Trim.ToUpper
        For i = 0 To DataGridView1.RowCount - 1
            If DataGridView1.Rows(i).Cells(colBusqueda).Value Is Nothing Then
                MsgBox("No se encontr el argumento de busqueda (" + argBusqueda + ") en la columna (" + DataGridView1.Columns(colBusqueda).Name + ")")
                Exit For
            End If
            valorCelda = DataGridView1.Rows(i).Cells(colBusqueda).Value.ToString.ToUpper
            If CheckBox1.Checked Then
                If valorCelda.CompareTo(argBusqueda) = 0 Then
                    DataGridView1.Rows(i).Selected = True
                    DataGridView1.CurrentCell = DataGridView1.Rows(i).Cells(colBusqueda)
                    Exit For
                End If
            Else
                If valorCelda.CompareTo(argBusqueda) >= 0 Then
                    DataGridView1.Rows(i).Selected = True
                    DataGridView1.CurrentCell = DataGridView1.Rows(i).Cells(colBusqueda)
                    Exit For
                End If
            End If

        Next i
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Dim i As Integer
        Dim nombreCol As String
        colBusqueda = 0
        nombreCol = ComboBox1.SelectedItem.ToString
        For i = 0 To DataGridView1.ColumnCount - 1
            If nombreCol = DataGridView1.Columns(i).Name Then
                DataGridView1.Sort(DataGridView1.Columns(i), System.ComponentModel.ListSortDirection.Ascending)
                DataGridView1.Refresh()
                colBusqueda = i
                Exit For
            End If
        Next i
    End Sub
End Class